# encoding: utf-8
__copyright__ = "Copyright (C) 2015 University of Wisconsin SSEC. All rights reserved."

from datetime import datetime, timedelta

JPSS_EPOCH = datetime(1958, 1, 1)
UNIX_EPOCH = datetime(1970, 1, 1)


def unixtime(dt):
    """
    Datetime to Unix timestamp.
    """
    if dt > UNIX_EPOCH:
        return (dt - UNIX_EPOCH).total_seconds()
    return (UNIX_EPOCH - dt).total_seconds()


def cds_to_timestamp(days, millis, microseconds, epoch):
    """
    CDS to unix timestamp seconds.
    """
    return epoch + (86400 * days) + (millis / 1000.) + (microseconds / 1000000.)


def cds_stamp(days, millis, microseconds, epoch=JPSS_EPOCH):
    """
    CCSDS Day Segmented timecode to UTC datetime.
    """
    return epoch + timedelta(days=days,
                             seconds=millis / 1000.0 + (microseconds / 1000000.))
